package com.hfkj.dao;

import com.hfkj.entity.BsTradeSettle;
import com.hfkj.entity.BsTradeSettleExample.Criteria;
import com.hfkj.entity.BsTradeSettleExample.Criterion;
import com.hfkj.entity.BsTradeSettleExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsTradeSettleSqlProvider {

    public String countByExample(BsTradeSettleExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_trade_settle");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsTradeSettleExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_trade_settle");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsTradeSettle record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_trade_settle");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanId() != null) {
            sql.VALUES("salesman_id", "#{salesmanId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanName() != null) {
            sql.VALUES("salesman_name", "#{salesmanName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.VALUES("mer_abbreviate", "#{merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.VALUES("store_id", "#{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.VALUES("platform_mer_no", "#{platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.VALUES("platform_trade_no", "#{platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformLogNo() != null) {
            sql.VALUES("platform_log_no", "#{platformLogNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayMode() != null) {
            sql.VALUES("pay_mode", "#{payMode,jdbcType=VARCHAR}");
        }
        
        if (record.getOutTradeNo() != null) {
            sql.VALUES("out_trade_no", "#{outTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccTradeNo() != null) {
            sql.VALUES("acc_trade_no", "#{accTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeType() != null) {
            sql.VALUES("trade_type", "#{tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.VALUES("trade_amount", "#{tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getTradeTime() != null) {
            sql.VALUES("trade_time", "#{tradeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.VALUES("shd_fee_amt", "#{shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.VALUES("settle_amount", "#{settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.VALUES("settle_date", "#{settleDate,jdbcType=DATE}");
        }
        
        if (record.getFeeRate() != null) {
            sql.VALUES("fee_rate", "#{feeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getOrgOutTradeNo() != null) {
            sql.VALUES("org_out_trade_no", "#{orgOutTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsTradeSettleExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("agent_id");
        sql.SELECT("salesman_id");
        sql.SELECT("salesman_name");
        sql.SELECT("mer_id");
        sql.SELECT("mer_name");
        sql.SELECT("mer_abbreviate");
        sql.SELECT("mer_no");
        sql.SELECT("store_id");
        sql.SELECT("store_name");
        sql.SELECT("platform_type");
        sql.SELECT("platform_mer_no");
        sql.SELECT("platform_trade_no");
        sql.SELECT("platform_log_no");
        sql.SELECT("pay_mode");
        sql.SELECT("out_trade_no");
        sql.SELECT("acc_trade_no");
        sql.SELECT("trade_type");
        sql.SELECT("trade_amount");
        sql.SELECT("trade_time");
        sql.SELECT("shd_fee_amt");
        sql.SELECT("settle_amount");
        sql.SELECT("settle_date");
        sql.SELECT("fee_rate");
        sql.SELECT("org_out_trade_no");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_trade_settle");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsTradeSettle record = (BsTradeSettle) parameter.get("record");
        BsTradeSettleExample example = (BsTradeSettleExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_settle");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanId() != null) {
            sql.SET("salesman_id = #{record.salesmanId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanName() != null) {
            sql.SET("salesman_name = #{record.salesmanName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.SET("mer_abbreviate = #{record.merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.SET("platform_mer_no = #{record.platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.SET("platform_trade_no = #{record.platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformLogNo() != null) {
            sql.SET("platform_log_no = #{record.platformLogNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayMode() != null) {
            sql.SET("pay_mode = #{record.payMode,jdbcType=VARCHAR}");
        }
        
        if (record.getOutTradeNo() != null) {
            sql.SET("out_trade_no = #{record.outTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccTradeNo() != null) {
            sql.SET("acc_trade_no = #{record.accTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeType() != null) {
            sql.SET("trade_type = #{record.tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.SET("trade_amount = #{record.tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getTradeTime() != null) {
            sql.SET("trade_time = #{record.tradeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.SET("shd_fee_amt = #{record.shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.SET("settle_amount = #{record.settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.SET("settle_date = #{record.settleDate,jdbcType=DATE}");
        }
        
        if (record.getFeeRate() != null) {
            sql.SET("fee_rate = #{record.feeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getOrgOutTradeNo() != null) {
            sql.SET("org_out_trade_no = #{record.orgOutTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_settle");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("salesman_id = #{record.salesmanId,jdbcType=BIGINT}");
        sql.SET("salesman_name = #{record.salesmanName,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("mer_abbreviate = #{record.merAbbreviate,jdbcType=VARCHAR}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_mer_no = #{record.platformMerNo,jdbcType=VARCHAR}");
        sql.SET("platform_trade_no = #{record.platformTradeNo,jdbcType=VARCHAR}");
        sql.SET("platform_log_no = #{record.platformLogNo,jdbcType=VARCHAR}");
        sql.SET("pay_mode = #{record.payMode,jdbcType=VARCHAR}");
        sql.SET("out_trade_no = #{record.outTradeNo,jdbcType=VARCHAR}");
        sql.SET("acc_trade_no = #{record.accTradeNo,jdbcType=VARCHAR}");
        sql.SET("trade_type = #{record.tradeType,jdbcType=INTEGER}");
        sql.SET("trade_amount = #{record.tradeAmount,jdbcType=DECIMAL}");
        sql.SET("trade_time = #{record.tradeTime,jdbcType=TIMESTAMP}");
        sql.SET("shd_fee_amt = #{record.shdFeeAmt,jdbcType=DECIMAL}");
        sql.SET("settle_amount = #{record.settleAmount,jdbcType=DECIMAL}");
        sql.SET("settle_date = #{record.settleDate,jdbcType=DATE}");
        sql.SET("fee_rate = #{record.feeRate,jdbcType=DECIMAL}");
        sql.SET("org_out_trade_no = #{record.orgOutTradeNo,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsTradeSettleExample example = (BsTradeSettleExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsTradeSettle record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_settle");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanId() != null) {
            sql.SET("salesman_id = #{salesmanId,jdbcType=BIGINT}");
        }
        
        if (record.getSalesmanName() != null) {
            sql.SET("salesman_name = #{salesmanName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.SET("mer_abbreviate = #{merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.SET("platform_mer_no = #{platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.SET("platform_trade_no = #{platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformLogNo() != null) {
            sql.SET("platform_log_no = #{platformLogNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayMode() != null) {
            sql.SET("pay_mode = #{payMode,jdbcType=VARCHAR}");
        }
        
        if (record.getOutTradeNo() != null) {
            sql.SET("out_trade_no = #{outTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccTradeNo() != null) {
            sql.SET("acc_trade_no = #{accTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeType() != null) {
            sql.SET("trade_type = #{tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.SET("trade_amount = #{tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getTradeTime() != null) {
            sql.SET("trade_time = #{tradeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.SET("shd_fee_amt = #{shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.SET("settle_amount = #{settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.SET("settle_date = #{settleDate,jdbcType=DATE}");
        }
        
        if (record.getFeeRate() != null) {
            sql.SET("fee_rate = #{feeRate,jdbcType=DECIMAL}");
        }
        
        if (record.getOrgOutTradeNo() != null) {
            sql.SET("org_out_trade_no = #{orgOutTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsTradeSettleExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}